#!/usr/bin/perl -U
#
# Licensed Materials - Property of IBM
# 
# 5724-A36
# 
# (C) Copyright IBM Corporation 2000. All Rights Reserved.
# 
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#

#
# chngrootpass.pl changes the root user password
#
# Sarah McCain <smccain@us.ibm.com> <12 October 1999>
#

use ASM::Common;
commonInit(["password=s", "oldpassword=s"],
	   "--password=PASSWORD --oldpassword=OLDPASSWORD");

$run_chpasswd = "/usr/sbin/chpasswd";
$auditCommand = "$auditcmd -o root syscfg";

my $usr_id = "root";

if (($opt_password) && ($opt_oldpassword)) {

	# Test to see if the "new"password equals the existing root password
	# If it does, assume the routine was called to validate the password (not change it)
	# and exit with success

	my $got_pass = &getPass($usr_id);

	if(crypt($opt_password, $got_pass) eq $got_pass)
	{
		exit(0);
	}

	# new password is different than existing password, attempt to change it

	&checkOldPass($opt_oldpassword);
	&chngThePass($opt_password);
} else {
  logUsage();
  exit(1);
}

exit (0);

############################################
#	SubRoutines BaBaaY
############################################

sub checkOldPass {
	my $old_pass = shift(@_);
	my $got_pass = &getPass($usr_id);

	# Test to see if passwords match or else exit with code 3.
	if(crypt($old_pass, $got_pass) ne $got_pass)
        {
	  error(MSG_E10);	# password was incorrect
		exit(3);
	}

} #checkOldPass

sub chngThePass {
	my $new_pass = shift(@_);

	my ($rc, $stdout, $stderr);
	$rc = runit_notrace(["echo $usr_id:$new_pass | $run_chpasswd"],
			    \$stdout, \$stderr);
	if ($rc == 0) {
	  audit(MSG_USER_PASSWORD_CHANGED, "root");
	} else {
	  trace("error changing password: rc=$rc\n$stdout\n$stderr");
	  error(MSG_UNEXPECTED_ERROR);
	  exit(5);
	}
} #chngThePass
