#!/usr/bin/perl -w
#
# Licensed Materials - Property of IBM
# 
# 5724-A36
# 
# (C) Copyright IBM Corporation 2000. All Rights Reserved.
# 
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#
use Getopt::Std;
use ASM::Log;
use ASM::MessageCodes;

require "/opt/CSM/scripts/utils.pl";

use vars qw! $opt_f !;

#################################
#DIRECTORY & FILES STRUCTURE
#################################
my($basedir) 		= "/opt/CSM";
my($statusdir) 		= "/data/status";


#GRAB THE COMMAND LINE PARAMETERS -F FILENAME
getopts("f:");

   ####################################################################################3
   # OPEN UP THE LOG FILE
   # THE LOG FILE CONTAINS ALL THE HISTORY
   ####################################################################################3
   open (LOGFH,"< $basedir$statusdir/$opt_f") || alreadyPurgedMessage();

   my($linecount)=0;
 
   my($keyword) = "%%%ps";

   my $cursor = 0;
   while (<LOGFH>) {
      # SEARCH FOR THE KEYWORD 
      # ON THE FIRST INSTANCE TURN ON.
      # FOR THE SECOND INSTANCE TURN OFF.  
      if(/$keyword/) { 
         if($cursor==0)	{$cursor=1;}
         else 		{$cursor=0;} 
      }

      # PRINT THE DATE, WHICH IS ENCODED ON THE SECOND LINE OF THE LOGFILE.
      if($cursor == 1)
      {
         $linecount++;
         if($linecount==2) {s/\./ /g; print "<b>$_</b>";}
         else 
         {
            if ($linecount > 2)
            {
               print $_;
            }
         }
      }

   }

#######################################################################################
########################## END OF PROGRAM #############################################
#######################################################################################
