#!/usr/bin/perl -U
#
# Licensed Materials - Property of IBM
# 
# 5724-A36
# 
# (C) Copyright IBM Corporation 2000. All Rights Reserved.
# 
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#

#
#
# logaction.pl - Run actions against the logs specified in apachectl and adminctl.
#
# Lewis Boehm <lboehm@us.ibm.com>
#
#

use ASM::Common;
use ASM::Exec;

my ($rc, $stdout, $stderr);

sub FindLog {FindStr};

$logaction = $ARGV[0] if ( ($ARGV[0] eq "query") || ($ARGV[0] eq "delete"));
die "Invalid log action: $!" if $logaction eq "";

if ($logaction eq "query")
{
   # Get the server
   $server = $ARGV[1] if ( ($ARGV[1] eq "adminctl") || ($ARGV[1] eq "apachectl"));
   die "Invalid server: $!" if $server eq "";

   # Get the Action
   $logtype = $ARGV[2] if ( ($ARGV[2] eq "ErrorLog") || ($ARGV[2] eq "TransferLog") || ($ARGV[2] eq "CookieLog") || ($ARGV[2] eq "CustomLog"));

   if ($server eq "adminctl") 
   {
      $filename = "/opt/IBMHTTPServer/conf/admin.conf";
   }
   else
   {
      $filename = "/opt/IBMHTTPServer/conf/httpd.conf"
   }

   if ($logtype ne "")
   {
      openOrDie( CONFFILE, "<$filename" );
      @allLines = <CONFFILE>;
      close(CONFFILE);
      FindLog( "ServerRoot" );
      FindLog( $logtype );
 
      $exitrc=0;

   }
   else 
   {
      
      if (-e $filename)
      {
	      $exitrc=0;
      }
      else 
      {
         $exitrc=1;
      }
	}
}
elsif ($logaction eq "delete")
{
   $filename = $ARGV[1] if ( ($ARGV[1] ne ""));
   if ($filename eq "") {
     error(MSG_FILENAME_REQUIRED);
     exit(1);
   }
   $cmd = "cat /dev/null > " . $filename;
   $rc = runit(["cat /dev/null >$filename"], \$stdout, \$stderr);
   trace("failed: rc=$rc\n$stdout\n$stderr") if $rc;
   exit(1) if $rc;
   $exitrc=0;
}


exit($exitrc);


################################
# Lookout!  Subroutines below! #
################################
 
sub FindLog
{
   for ( $x=0 ; $x <= $#allLines ; $x++)
      {
         if ( index ( $allLines[$x],$_[0] ) == 0 )
         {
            print "@@" . $allLines[$x];
         }
      }
}
