#!/usr/bin/perl -U
#
# Licensed Materials - Property of IBM
# 
# 5724-A36
# 
# (C) Copyright IBM Corporation 2000. All Rights Reserved.
# 
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#

#
# queryImage.pl - 
#

use ASM::Common;

use strict;
my ($eSP_BIN, @opts, $queryImage_usage, $cmd);
my ($rc, $stdout, $stderr);

$eSP_BIN = "/opt/CSM/scripts";

require "$eSP_BIN/common_install.pl";

use vars qw/ $opt_help $opt_hist /;

# Parse the arguments
@opts = ("hist");
$queryImage_usage = "\t\tor\nqueryImage.pl [--hist]\n Show the current Appliance Software Update Level. Use the hist option to show all previously installed update packages. ";

commonInit(\@opts, $queryImage_usage);

setFacility('upgrade');

sub cleanup_exit
{
   my ($exitmsg, $exitrc) = @_;

   trace("$exitmsg");
   trace("exit $exitrc");
  
   if ($exitrc != 0)
   {
      error(MSG_UPDATE_QUERY_FAILED);
   }
   else
   {
      audit(MSG_UPDATE_QUERY_COMPLETED);
   }

   exit($exitrc);
}

if ($opt_hist)
{
   if (&displayUpdates())
   {
      &cleanup_exit("Normal exit.", 0);
   }
   else
   {
      &cleanup_exit("Problem getting list of installed updates.", 1);
   }
}
else
{
   $cmd = `rpm -q --queryformat \"%{NAME}-%{VERSION}-%{RELEASE}\" ibmasmRelease`;
   print "$cmd";
}
