#!/usr/bin/perl -U
#
# Licensed Materials - Property of IBM
# 
# 5724-A36
# 
# (C) Copyright IBM Corporation 2000. All Rights Reserved.
# 
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#

#
# runit.pl - A wrapper script to allow 'nobody' to run root scripts
#
# Wayne Gao, <waynegao@us.ibm.com> (27 Octobe 1999)
#


use Getopt::Long;
use User::pwent;

$eSP_BIN='/opt/CSM/scripts';
$ws_user_id=99;
$LOG='/tmp/runit.log';
$RC='/tmp/RC';
$n_arg=@ARGV;

@opts = ("admin=s");

&GetOptions(@opts);
`cat /dev/null > $LOG`;

$s_name="$eSP_BIN/$ARGV[0]";
if ( ! -f $s_name ) {
  `echo "ERROR: $s_name does not exist">>$LOG`;
  `echo "++ exit 1">>$LOG`; 
   print "+++ Last few lines of $LOG +++\n";
  $stn=`tail -10 $LOG`;
  print "$stn";
  exit 1;
}

#
# check for administrator's name
#

if ($opt_admin)
{
  $s_name = "$s_name -a $opt_admin";
}
  
if ($n_arg > 1) {
   for ($j=1; $j<$n_arg; $j++) {
     $s_name="$s_name $ARGV[$j]";
   }
}
`echo "Run: $s_name">$LOG`;
`echo "uid to run the script must be 0 or 99">>$LOG`;
`echo "your id is: $<" >>$LOG`;

# Check if the user is nobody or root
if ($< != $ws_user_id && $< != 0) {
  `echo "You do not have permission to run: $s_name.">>$LOG`;
  exit 1;
}
# Execute the script
`echo "Excecute the script: $s_name">>$LOG`;
system("$s_name");

# The system command does not really return the exit value of
# the command it executes. Some work around: use file $RC to
# pass the exit value of $s_name.

if ( -f $RC ) {
  $rc=`cat $RC`;
  chop $rc;
  `echo "Exit code for $s_name is: $rc">>$LOG`;
  `echo "rm -f $RC" >>$LOG`;
  `rm -f $RC`;
} else {
  `echo "++ WARNING: exit code is not passed to system command, assume 0">>$LOG`;
  $rc=0;
}
exit $rc;

