#!/usr/bin/perl -U
#
# Licensed Materials - Property of IBM
# 
# 5724-A36
# 
# (C) Copyright IBM Corporation 2000. All Rights Reserved.
# 
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#

#
#
# shutdown.pl - Checks password and either reboots or halts machine.
#
# Paul Schroeder <paulsch@us.ibm.com> (30 September 1999)
# Sarah McCain <smccain@us.ibm.com> (18 October 1999)
# - changed the password information
# Dan Poirier <poirier@Us.ibm.com> (7 August 2000)
# - Don't require password, rely on Web server security to block
#   access to shutdown screen.
#

@shutdown_opts = ("password=s", "halt", "reboot");
$shutdown_usage = "shutdown.pl [ --password=PASSWORD ] --halt\n" . "shutdown.pl [ --password=PASSWORD ] --reboot\n";

use ASM::Common;
use ASM::Exec;
commonInit(\@shutdown_opts, $shutdown_usage);


$shutdown_halt = "/sbin/shutdown -h now";
$shutdown_reboot = "/sbin/shutdown -r now";
$auditCommand = "$auditcmd initsys";

my ($stdout, $stderr);

if($opt_halt) {
  audit(MSG_SHUTTING_DOWN_MESSAGE);
  if (runit([$shutdown_halt],\$stdout,\$stderr)) {
    trace("shutdown failed\n$stdout\n$stderr");
    error(MSG_SHUTDOWN_FAILED);
    exit(4);
  }
} elsif($opt_reboot) {
        audit(MSG_REBOOTING_MESSAGE);
	if (runit([$shutdown_reboot],\$stdout,\$stderr)) {
	  trace("shutdown failed\n$stdout\n$stderr");
	  error(MSG_REBOOT_FAILED);
	  exit(4);
	}
} else {
	&logUsage();
}
exit(0);

