#!/usr/bin/perl -U
#
# Licensed Materials - Property of IBM
# 
# 5724-A36
# 
# (C) Copyright IBM Corporation 2000. All Rights Reserved.
# 
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#

#
# The source code for this program is not published or otherwise
# dievested of its trade secrets, irrespective of what has been
# deposited with the US Copyright Office
#
# sysLevel.pl - display current kernel version and most recent
#               installed software upgrade
#
# Wayne Gao, <waynegao@us.ibm.com> (28 Octobe 1999)
#

use ASM::Common;

use strict;
my ($eSP_BIN, $kernelpath, $c_knel, $c_knel_time, $r_knel, $len, $r_knel_time);
my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks);
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst);
my ($LOG1, $recent_pkg);

$eSP_BIN = "/opt/CSM/scripts";

require "$eSP_BIN/common_install.pl";

commonInit([],"");

setFacility('upgrade');

use vars qw/ $IMG_DIR $BK_DIR /;

$kernelpath = "/boot/vmlinuz";

trace("Start sysLevel.pl");

# Find the current running kernel:
$c_knel=`uname -r`;
chop ($c_knel);
($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat "$kernelpath-$c_knel";
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($mtime);
$year = $year + 1900;
$mon = $mon + 1;
$c_knel_time = "$mon/$mday/$year $hour:$min";

# Find the most recently installed kernel:
$r_knel=`grep image /etc/lilo.conf | grep -v $c_knel`; 
chop ($r_knel);
$len=`echo $r_knel|wc -c`;
if ( $len <= 2 ) {
   $r_knel=$c_knel;
} else {
  $r_knel =~ s/^image=\/boot\/vmlinuz//;
  if ($r_knel == "")
  {
     #  TurboLinux and SuSe use file links for kernel images
     $r_knel = readlink("/boot/vmlinuz");
     $r_knel =~ s/^vmlinuz-//;
  }
  else
  {
     #  RedHat uses actual kernel image file name
     $r_knel =~ s/^-//;
  }
}
($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat "$kernelpath-$r_knel";
$r_knel_time = $ctime;
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($mtime);
$year = $year + 1900;
$mon = $mon + 1;
$r_knel_time = "$mon/$mday/$year $hour:$min";


# Find the most recently installed upgrade package:
open LOG1, "ls -1t $BK_DIR |";
chop($recent_pkg = <LOG1>);
close LOG1;

$len=`echo $recent_pkg |wc -c`;
if ( $len <= 2 ) {
   $recent_pkg="None";
}

print getFormattedMessage(MSG_CURRENT_KERNEL_DATE, $c_knel, $c_knel_time) . "\n";
print getFormattedMessage(MSG_INSTALLED_KERNEL_DATE, $r_knel, $r_knel_time) . "\n";
print getFormattedMessage(MSG_INSTALLED_UPDATE, $recent_pkg) . "\n";
exit 0;
